﻿using System.Drawing.Drawing2D;
using ProjectCruiser.Entities;
namespace ProjectCruiser.DrawningSamples;

public class DrawningCruiser : DrawningBase
{
    // Инициализация свойств (все параметры класса (сущности))
    public DrawningCruiser(EntityCruiser ship) : base((EntityBase)ship)
    {
        EntityTransport = ship;
    }

    public override void DrawTransport(Graphics g)
    {
        if (EntityTransport == null ||
            EntityTransport is not EntityCruiser ship ||
            !_startPosX.HasValue || !_startPosY.HasValue)
        {
            return;
        }

        Pen pen = new(Color.Black, 2);
        Brush PadBrush = new HatchBrush(HatchStyle.DottedDiamond, Color.LightGray, Color.Black);
        Brush additionalBrush = new SolidBrush(ship.AdditionalColor);

        //границы cruiser <...>
        // &
        // салон на верхней палубе :

        base.DrawTransport(g);

        // вертолетная площадка - non-default
        if (ship.HelicopterPads)
        {
            g.DrawEllipse(pen, _startPosX.Value + 170, _startPosY.Value + 11, 20, 20);
            g.FillEllipse(PadBrush, _startPosX.Value + 170, _startPosY.Value + 11, 20, 20);
        }
        // ангар(ы)
        if (ship.Hangars)
        {
            g.FillRectangle(additionalBrush, _startPosX.Value + 80, _startPosY.Value + 10, 10, 20);
            g.FillRectangle(additionalBrush, _startPosX.Value + 70, _startPosY.Value + 12, 8, 12);
        }
        else g.FillRectangle(additionalBrush, _startPosX.Value + 250, _startPosY.Value + 20, 14, 7);
    }
}
