﻿namespace ProjectCruiser.DrawningSamples;

public class DrawningShipCompareByColor : IComparer<DrawningBase?>
{
    public int Compare(DrawningBase? x, DrawningBase? y)
    {
        if (x == null || x.EntityTransport == null)
        {
            return 1;
        }

        if (y == null || y.EntityTransport == null)
        {
            return -1;
        }

        var bodycolorCompare = x.EntityTransport.MainColor.Name.CompareTo(
            y.EntityTransport.MainColor.Name);

        if (bodycolorCompare != 0)
        {
            return bodycolorCompare;
        }

        var speedCompare = x.EntityTransport.Speed.CompareTo(y.EntityTransport.Speed);
        
        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityTransport.Weight.CompareTo(y.EntityTransport.Weight);
    }
}
