﻿namespace ProjectCruiser.MoveStrategy;

// Интерфейс для работы с перемещаемым объектом
public interface IMoveableObj
{
    // Получение координат объекта
    ObjParameters? GetObjectPosition { get; }

    // Получение шага объекта
    int GetStep { get; }

    /// Попытка переместить объект в указанном направлении
    /// <param name="direction">Направление</param>
    /// <returns>true - объект перемещен, false - перемещение невозможно</returns>
    bool TryMoveObject(MovementDirection direction);
}
