﻿namespace ProjectCruiser.MoveStrategy;

// Параметры-координаты объекта
public class ObjParameters
{
    private readonly int _x;
    private readonly int _y;

    private readonly int _width; // Ширина объекта
    private readonly int _height; // Высота объекта

    public int LeftBorder => _x; // Левая граница
    public int TopBorder => _y; // Верхняя граница
    public int RightBorder => _x + _width; // Правая граница
    public int DownBorder => _y + _height; // Нижняя граница

    // Вертикальная середина объекта
    public int ObjectMiddleHorizontal => _x + _width / 2;
    // Горизонтальная середина объекта
    public int ObjectMiddleVertical => _y + _height / 2;

    public ObjParameters(int x, int y, int width, int height)
    {
        _x = x;
        _y = y;
        _width = width;
        _height = height;
    }
}
